﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.TeamFoundation.Client;
using Microsoft.TeamFoundation.Framework.Client;
using System.Collections.ObjectModel;
using System.Diagnostics;
using Microsoft.TeamFoundation.Framework.Common;
using System.Configuration;

namespace TfsSdk_ConnectToTfsProgrammatically
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Update the AppConfig with the URI of the Team Foundation Server you want to connect to, Make sure you have View Team Project Collection Details permissions on the server
        private static string _myUri = ConfigurationManager.AppSettings["TfsUri"];

        private void button1_Click(object sender, EventArgs e)
        {
            lblNotes.Text = string.Empty;

            try
            {
                StringBuilder notes = new StringBuilder();

                TfsConfigurationServer configurationServer =
                TfsConfigurationServerFactory.GetConfigurationServer(new Uri(_myUri));

                CatalogNode catalogNode = configurationServer.CatalogNode;

                ReadOnlyCollection<CatalogNode> tpcNodes = catalogNode.QueryChildren(
                    new Guid[] { CatalogResourceTypes.ProjectCollection },
                    false, CatalogQueryOptions.None);

                // tpc = Team Project Collection
                foreach (CatalogNode tpcNode in tpcNodes)
                {
                    Guid tpcId = new Guid(tpcNode.Resource.Properties["InstanceId"]);
                    TfsTeamProjectCollection tpc = configurationServer.GetTeamProjectCollection(tpcId);

                    notes.AppendFormat("{0} Team Project Collection : {1}{0}", Environment.NewLine, tpc.Name);

                    // Get catalog of tp = 'Team Projects' for the tpc = 'Team Project Collection'
                    var tpNodes = tpcNode.QueryChildren(
                        new Guid[] { CatalogResourceTypes.TeamProject },
                        false, CatalogQueryOptions.None);

                    foreach (var p in tpNodes)
                    {
                        notes.AppendFormat("{0} Team Project : {1} - {2}{0}", Environment.NewLine, p.Resource.DisplayName, p.Resource.Description);
                    }
                }
                lblNotes.Text = notes.ToString();
            }
            catch (Exception ex)
            {
                lblError.Text = " Message : " + ex.Message + (ex.InnerException != null ? " Inner Exception : " + ex.InnerException : string.Empty); 
            }
        }
    }
}
